package com.nuparu.lumina.items;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.Optional;

import net.minecraft.world.World;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.EnumHand;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.ActionResult;
import net.minecraft.stats.StatList;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.item.EnumAction;
import net.minecraft.init.SoundEvents;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.Entity;

import mod.mcreator.lumina;

import com.nuparu.lumina.utils.ColorRGB;
import com.nuparu.lumina.entity.EntityGlowstick;

import com.elytradev.mirage.lighting.Light;
import com.elytradev.mirage.lighting.IEntityLightEventConsumer;
import com.elytradev.mirage.event.GatherLightsEvent;

public class ItemGlowstick extends Item implements IEntityLightEventConsumer {

	public ColorRGB color;

	public ItemGlowstick(ColorRGB color) {
		this.color = color;
	}

	@Optional.Method(modid = "mirage")
	@SideOnly(Side.CLIENT)
	@Override
	public void gatherLights(GatherLightsEvent evt, Entity e) {
		evt.add(Light.builder().pos(e).color(color.R, color.G, color.B).radius(5).build());
	}

	public void onPlayerStoppedUsing(ItemStack stack, World worldIn, EntityLivingBase entityLiving, int timeLeft) {
		if (entityLiving instanceof EntityPlayer) {
			EntityPlayer entityplayer = (EntityPlayer) entityLiving;
			int i = this.getMaxItemUseDuration(stack) - timeLeft;
			if (i < 0)
				return;
			worldIn.playSound((EntityPlayer) null, entityplayer.posX, entityplayer.posY, entityplayer.posZ, SoundEvents.ENTITY_SNOWBALL_THROW,
					SoundCategory.NEUTRAL, 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
			if (!worldIn.isRemote) {
				EntityGlowstick entityglowstick = new EntityGlowstick(worldIn, entityplayer);
				ItemStack itemstack = stack.copy();
				stack.setCount(1);
				entityglowstick.setStack(itemstack);
				entityglowstick.shoot(entityplayer, entityplayer.rotationPitch, entityplayer.rotationYaw, 0.0F, getVelocity(i), 1.0F);
				worldIn.spawnEntity(entityglowstick);
			}
			entityplayer.addStat(StatList.getObjectUseStats(this));
						if (!entityplayer.capabilities.isCreativeMode) {
				stack.shrink(1);
			}

		}
	}

	public static float getVelocity(int charge) {
		float f = (float) charge / 20.0F;
		f = (f * f + f * 2.0F) / 3.0F;
		if (f > 1.0F) {
			f = 1.0F;
		}
		return f;
	}

	public int getMaxItemUseDuration(ItemStack stack) {
		return 72000;
	}

	public EnumAction getItemUseAction(ItemStack stack) {
		return EnumAction.BOW;
	}

	public ActionResult<ItemStack> onItemRightClick(World worldIn, EntityPlayer playerIn, EnumHand handIn) {
		ItemStack itemstack = playerIn.getHeldItem(handIn);
		playerIn.setActiveHand(handIn);
		return new ActionResult<ItemStack>(EnumActionResult.SUCCESS, itemstack);
	}
}
